//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%399D65D4009E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%399D65D4009E.cm

//## begin module%399D65D4009E.cp preserve=no
//## end module%399D65D4009E.cp

//## Module: OGIP-92aData%399D65D4009E; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/OGIP-92aData.h

#ifndef OGIP_92ADATA_H
#define OGIP_92ADATA_H 1

//## begin module%399D65D4009E.additionalIncludes preserve=no
//## end module%399D65D4009E.additionalIncludes

//## begin module%399D65D4009E.includes preserve=yes
//## end module%399D65D4009E.includes

// DataSet
#include <XSModel/Data/DataSet.h>
// OGIP-92aIO
#include <XSModel/DataFactory/OGIP-92aIO.h>
//## begin module%399D65D4009E.declarations preserve=no
//## end module%399D65D4009E.declarations

//## begin module%399D65D4009E.additionalDeclarations preserve=yes
#include <XSModel/Data/SpectralData.h>
//## end module%399D65D4009E.additionalDeclarations


//## begin OGIP_92aData%363DDBB40334.preface preserve=yes
//## end OGIP_92aData%363DDBB40334.preface

//## Class: OGIP-92aData%363DDBB40334
//	Implementation for OGIP 1992a standard data.
//	This class will handle the OGIP Type I format
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39FDA7730344;DataSetBase { -> }
//## Uses: <unnamed>%3A02EA9402A9;SpectralData { -> }

class OGIP_92aData : public DataSet, //## Inherits: <unnamed>%3AA906AA00C3
                     	public OGIP_92aIO  //## Inherits: <unnamed>%3BF52E41004A
{
  //## begin OGIP_92aData%363DDBB40334.initialDeclarations preserve=yes
  //## end OGIP_92aData%363DDBB40334.initialDeclarations

  private:
    //## begin OGIP_92aData::OutputInfo%3EF7200901BA.preface preserve=yes
    //## end OGIP_92aData::OutputInfo%3EF7200901BA.preface

    //## Class: OutputInfo%3EF7200901BA; private
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class OutputInfo 
    {
      //## begin OGIP_92aData::OutputInfo%3EF7200901BA.initialDeclarations preserve=yes
      //## end OGIP_92aData::OutputInfo%3EF7200901BA.initialDeclarations

      public:
        //## Constructors (specified)
          //## Operation: OutputInfo%3EF724560261
          OutputInfo (const string& fileName, const SpectralData* sd, const std::vector<string>& respNames, const std::vector<string>& arfNames, const string& bckName, const string& corrName, const RealArray& bckScaleRatio, const Real corrScale, const std::vector<string>& modelNames, bool aScaleIsKeyword, bool bScaleIsKeyword);

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: fileName%3EF7203C00A4
          const string& fileName () const;

          //## Attribute: sd%3EF72065014A
          const SpectralData* sd () const;

          //## Attribute: respNames%3EF722E10231
          const std::vector<string>& respNames () const;

          //## Attribute: arfNames%3EF722F403C6
          const std::vector<string>& arfNames () const;

          //## Attribute: bckName%3EF7230602FF
          const string& bckName () const;

          //## Attribute: corrName%3EF72316034A
          const string& corrName () const;

          //## Attribute: bckScaleRatio%3EF72321022B
          const RealArray& bckScaleRatio () const;

          //## Attribute: corrScale%3EF73D3500CB
          const Real corrScale () const;

          //## Attribute: modelNames%3EFC58A900FF
          const std::vector<string>& modelNames () const;

          //## Attribute: isAScaleKeyword%3F818618015D
          bool isAScaleKeyword () const;

          //## Attribute: isBScaleKeyword%3F8186480190
          bool isBScaleKeyword () const;

        // Additional Public Declarations
          //## begin OGIP_92aData::OutputInfo%3EF7200901BA.public preserve=yes
          //## end OGIP_92aData::OutputInfo%3EF7200901BA.public

      protected:
        // Additional Protected Declarations
          //## begin OGIP_92aData::OutputInfo%3EF7200901BA.protected preserve=yes
          //## end OGIP_92aData::OutputInfo%3EF7200901BA.protected

      private:
        // Additional Private Declarations
          //## begin OGIP_92aData::OutputInfo%3EF7200901BA.private preserve=yes
          //## end OGIP_92aData::OutputInfo%3EF7200901BA.private

      private: //## implementation
        // Data Members for Class Attributes

          //## begin OGIP_92aData::OutputInfo::fileName%3EF7203C00A4.attr preserve=no  public: const string& {U} 
          const string& m_fileName;
          //## end OGIP_92aData::OutputInfo::fileName%3EF7203C00A4.attr

          //## begin OGIP_92aData::OutputInfo::sd%3EF72065014A.attr preserve=no  public: const SpectralData* {U} 
          const SpectralData* m_sd;
          //## end OGIP_92aData::OutputInfo::sd%3EF72065014A.attr

          //## begin OGIP_92aData::OutputInfo::respNames%3EF722E10231.attr preserve=no  public: const std::vector<string> {U} 
          const std::vector<string> m_respNames;
          //## end OGIP_92aData::OutputInfo::respNames%3EF722E10231.attr

          //## begin OGIP_92aData::OutputInfo::arfNames%3EF722F403C6.attr preserve=no  public: const std::vector<string> {U} 
          const std::vector<string> m_arfNames;
          //## end OGIP_92aData::OutputInfo::arfNames%3EF722F403C6.attr

          //## begin OGIP_92aData::OutputInfo::bckName%3EF7230602FF.attr preserve=no  public: const string& {U} 
          const string& m_bckName;
          //## end OGIP_92aData::OutputInfo::bckName%3EF7230602FF.attr

          //## begin OGIP_92aData::OutputInfo::corrName%3EF72316034A.attr preserve=no  public: const string& {U} 
          const string& m_corrName;
          //## end OGIP_92aData::OutputInfo::corrName%3EF72316034A.attr

          //## begin OGIP_92aData::OutputInfo::bckScaleRatio%3EF72321022B.attr preserve=no  public: const RealArray& {U} 
          const RealArray& m_bckScaleRatio;
          //## end OGIP_92aData::OutputInfo::bckScaleRatio%3EF72321022B.attr

          //## begin OGIP_92aData::OutputInfo::corrScale%3EF73D3500CB.attr preserve=no  public: const Real {U} 
          const Real m_corrScale;
          //## end OGIP_92aData::OutputInfo::corrScale%3EF73D3500CB.attr

          //## begin OGIP_92aData::OutputInfo::modelNames%3EFC58A900FF.attr preserve=no  public: const std::vector<string>& {U} 
          const std::vector<string>& m_modelNames;
          //## end OGIP_92aData::OutputInfo::modelNames%3EFC58A900FF.attr

          //## begin OGIP_92aData::OutputInfo::isAScaleKeyword%3F818618015D.attr preserve=no  public: bool {U} 
          bool m_isAScaleKeyword;
          //## end OGIP_92aData::OutputInfo::isAScaleKeyword%3F818618015D.attr

          //## begin OGIP_92aData::OutputInfo::isBScaleKeyword%3F8186480190.attr preserve=no  public: bool {U} 
          bool m_isBScaleKeyword;
          //## end OGIP_92aData::OutputInfo::isBScaleKeyword%3F8186480190.attr

        // Additional Implementation Declarations
          //## begin OGIP_92aData::OutputInfo%3EF7200901BA.implementation preserve=yes
          //## end OGIP_92aData::OutputInfo%3EF7200901BA.implementation

    };

    //## begin OGIP_92aData::OutputInfo%3EF7200901BA.postscript preserve=yes
    //## end OGIP_92aData::OutputInfo%3EF7200901BA.postscript

  public:
    //## Constructors (generated)
      OGIP_92aData();

      OGIP_92aData(const OGIP_92aData &right);

    //## Destructor (generated)
      virtual ~OGIP_92aData();


    //## Other Operations (specified)
      //## Operation: clone%39940FF501F3
      virtual OGIP_92aData* clone () const;

      //## Operation: fileFormat%399D65780118
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: initialize%3A1C117502C5
      virtual void initialize (DataPrototype* proto, DataInputRecord& record);

      //## Operation: closeSourceFiles%3A393F350115
      void closeSourceFiles ();

      //## Operation: setResponse%3A5F1F150235
      //	setData processes the input file for a single source
      //	spectrum into a data object (e.g. SpectrumData,
      //	ResponseData). For files with multiple sources,
      //	e.g. OGIP type II files, setData will be called once for
      //	each data row to be read.
      virtual void setResponse (size_t spectrumNumber, size_t row = 0);

      //## Operation: reportResponse%3C0406BB0119
      virtual void reportResponse (size_t row) const;

      //## Operation: setResponse%3CD6A00902E5
      virtual bool setResponse (SpectralData* sourceSpectrum, size_t spectrumNumber, size_t sourceNum, const string& responseName, const string& arfName);

      //## Operation: setBackgroundData%3D1C8F470352
      virtual bool setBackgroundData (size_t row = 0, int bckRow = -1);

      //## Operation: setCorrectionData%3D1C8FCD017A
      virtual bool setCorrectionData (size_t row = 0, int corRow = -1);

      //## Operation: initializeFake%3E89E638023D
      virtual void initializeFake (DataPrototype* proto, FakeDataInputRecord& record);

      //## Operation: outputData%3E9D8CE60034
      virtual void outputData ();

      //## Operation: getAncillaryLocation%3EB9694803AA
      virtual FakeDataInputRecord::Arfs getAncillaryLocation (size_t rowNum, const FakeDataInputRecord::Detectors& respInfo) const;

      //## Operation: getBackCorrLocation%3EB9695002AB
      virtual std::pair<string,size_t> getBackCorrLocation (size_t rowNum, bool isCorr = false) const;

      //## Operation: getResponseName%41F91259032B
      virtual FakeDataInputRecord::Detectors getResponseName (size_t rowNum) const;

    // Additional Public Declarations
      //## begin OGIP_92aData%363DDBB40334.public preserve=yes
      //## end OGIP_92aData%363DDBB40334.public

  protected:

    //## Other Operations (specified)
      //## Operation: copy%399C27D8002C;  C++
      virtual void copy (const DataSet& right);

      //## Operation: setArrays%3A01C3DC0284
      virtual void setArrays (size_t row = 0);

      //## Operation: setDescription%3A01C3E5022B
      virtual void setDescription (size_t spectrumNumber = 1, size_t row = 0);

      //## Operation: groupArrays%3A01CA2E0162
      virtual void groupArrays (size_t row = 0);

      //## Operation: setAncillaryFileName%3A26B3F900DF
      //	This is the equivalent of fpauxf
      void setAncillaryFileName (string& outFileName, const string& matchName, const string& key, const string& suffix, size_t row = 0);

      //## Operation: setAncillaryData%3A26CF460139
      //	Abstract function to be called by setData.
      //
      //	Invokes methods that instantiate ancilliary
      //	datasets in the case of DataSet and Response
      //	classes.
      //
      //	Default implementation is to do nothing.
      virtual bool setAncillaryData (size_t row = 0, int ancRow = -1);

      //## Operation: isCounts%3A366FAB0122
      virtual bool isCounts () const;

      //## Operation: Swap%3A95790D0057
      virtual void Swap (DataSet& right);

      //## Operation: match%3AC0F9150361
      bool match (const IntegerArray& srcValue, const IntegerArray& value);

      //## Operation: getNChansForFake%3ED3B0CE018D
      virtual void getNChansForFake (FakeDataInputRecord& record, const size_t index, SpectralData::ChannelInfo& chanInfo);

      //## Operation: writeCommonKeys%3EDFB53803B8
      virtual void writeCommonKeys (CCfits::Table* tbl);

      //## Operation: isNet%3FD88DDD0051
      //	OGIP files can have a NET indicator that the file is
      //	background subtracted. This is used in groupArrays.
      virtual bool isNet (const RealArray& spectrum);

    // Additional Protected Declarations
      //## begin OGIP_92aData%363DDBB40334.protected preserve=yes
      //## end OGIP_92aData%363DDBB40334.protected

  private:
    //## Assignment Operation (generated)
      OGIP_92aData & operator=(const OGIP_92aData &right);


    //## Other Operations (specified)
      //## Operation: outputType1Table%3EF727CB00D6
      void outputType1Table ();

      //## Operation: outputType2Table%3EF72809019C
      void outputType2Table ();

      //## Operation: outputTable1Common%3EF7282F017E
      void outputTable1Common (const OutputInfo& info);

      //## Operation: outputTable2Common%3EF7387903C7
      void outputTable2Common (const OutputInfo& info, size_t row, const BoolArray& optCols);

      //## Operation: setFilterKeys%3F71C21D00C3
      void setFilterKeys (size_t row);

      //## Operation: scaleVector%3F71C37A0084
      RealArray scaleVector (const string& key, int row, int first, int last);

      //## Operation: fakeitModRespHistory%47CECCCF01B2
      static void fakeitModRespHistory (CCfits::Table* tbl, const OutputInfo& info, size_t rowNum);

      //## Operation: collectRespArfNames%47D06953022E
      static void collectRespArfNames (const std::vector<Response*>& detectors, std::vector<string>& respNames, std::vector<string>& arfNames);

      //## Operation: type2FakeitHistoryCols%47D18F5100DC
      static void type2FakeitHistoryCols (CCfits::Table* tbl, size_t nSources);

    // Additional Private Declarations
      //## begin OGIP_92aData%363DDBB40334.private preserve=yes
      //## end OGIP_92aData%363DDBB40334.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fkModRoot%47D18CAA01CE
      //## begin OGIP_92aData::fkModRoot%47D18CAA01CE.attr preserve=no  private: static string {UC} string("FKSRC")
      static const string s_fkModRoot;
      //## end OGIP_92aData::fkModRoot%47D18CAA01CE.attr

      //## Attribute: fkRspRoot%47D18CB80134
      //## begin OGIP_92aData::fkRspRoot%47D18CB80134.attr preserve=no  private: static string {UC} string("FKRSP")
      static const string s_fkRspRoot;
      //## end OGIP_92aData::fkRspRoot%47D18CB80134.attr

      //## Attribute: fkArfRoot%47D18CC2021F
      //## begin OGIP_92aData::fkArfRoot%47D18CC2021F.attr preserve=no  private: static string {UC} string("FKARF")
      static const string s_fkArfRoot;
      //## end OGIP_92aData::fkArfRoot%47D18CC2021F.attr

      //## Attribute: fkKeyValLen%47D6D75602B0
      //	Should equal FLEN_VALUE - 3, where FLEN_VALUE is defined
      //	in CFITSIO.  The 3 comes from spaces for quotes in the
      //	fits header, and a trailing null.
      //## begin OGIP_92aData::fkKeyValLen%47D6D75602B0.attr preserve=no  private: static size_t {UC} FLEN_VALUE - 3
      static const size_t s_fkKeyValLen;
      //## end OGIP_92aData::fkKeyValLen%47D6D75602B0.attr

    // Additional Implementation Declarations
      //## begin OGIP_92aData%363DDBB40334.implementation preserve=yes
      //## end OGIP_92aData%363DDBB40334.implementation

};

//## begin OGIP_92aData%363DDBB40334.postscript preserve=yes
//## end OGIP_92aData%363DDBB40334.postscript

// Class OGIP_92aData::OutputInfo 

//## Get and Set Operations for Class Attributes (inline)

inline const string& OGIP_92aData::OutputInfo::fileName () const
{
  //## begin OGIP_92aData::OutputInfo::fileName%3EF7203C00A4.get preserve=no
  return m_fileName;
  //## end OGIP_92aData::OutputInfo::fileName%3EF7203C00A4.get
}

inline const SpectralData* OGIP_92aData::OutputInfo::sd () const
{
  //## begin OGIP_92aData::OutputInfo::sd%3EF72065014A.get preserve=no
  return m_sd;
  //## end OGIP_92aData::OutputInfo::sd%3EF72065014A.get
}

inline const std::vector<string>& OGIP_92aData::OutputInfo::respNames () const
{
  //## begin OGIP_92aData::OutputInfo::respNames%3EF722E10231.get preserve=no
  return m_respNames;
  //## end OGIP_92aData::OutputInfo::respNames%3EF722E10231.get
}

inline const std::vector<string>& OGIP_92aData::OutputInfo::arfNames () const
{
  //## begin OGIP_92aData::OutputInfo::arfNames%3EF722F403C6.get preserve=no
  return m_arfNames;
  //## end OGIP_92aData::OutputInfo::arfNames%3EF722F403C6.get
}

inline const string& OGIP_92aData::OutputInfo::bckName () const
{
  //## begin OGIP_92aData::OutputInfo::bckName%3EF7230602FF.get preserve=no
  return m_bckName;
  //## end OGIP_92aData::OutputInfo::bckName%3EF7230602FF.get
}

inline const string& OGIP_92aData::OutputInfo::corrName () const
{
  //## begin OGIP_92aData::OutputInfo::corrName%3EF72316034A.get preserve=no
  return m_corrName;
  //## end OGIP_92aData::OutputInfo::corrName%3EF72316034A.get
}

inline const RealArray& OGIP_92aData::OutputInfo::bckScaleRatio () const
{
  //## begin OGIP_92aData::OutputInfo::bckScaleRatio%3EF72321022B.get preserve=no
  return m_bckScaleRatio;
  //## end OGIP_92aData::OutputInfo::bckScaleRatio%3EF72321022B.get
}

inline const Real OGIP_92aData::OutputInfo::corrScale () const
{
  //## begin OGIP_92aData::OutputInfo::corrScale%3EF73D3500CB.get preserve=no
  return m_corrScale;
  //## end OGIP_92aData::OutputInfo::corrScale%3EF73D3500CB.get
}

inline const std::vector<string>& OGIP_92aData::OutputInfo::modelNames () const
{
  //## begin OGIP_92aData::OutputInfo::modelNames%3EFC58A900FF.get preserve=no
  return m_modelNames;
  //## end OGIP_92aData::OutputInfo::modelNames%3EFC58A900FF.get
}

inline bool OGIP_92aData::OutputInfo::isAScaleKeyword () const
{
  //## begin OGIP_92aData::OutputInfo::isAScaleKeyword%3F818618015D.get preserve=no
  return m_isAScaleKeyword;
  //## end OGIP_92aData::OutputInfo::isAScaleKeyword%3F818618015D.get
}

inline bool OGIP_92aData::OutputInfo::isBScaleKeyword () const
{
  //## begin OGIP_92aData::OutputInfo::isBScaleKeyword%3F8186480190.get preserve=no
  return m_isBScaleKeyword;
  //## end OGIP_92aData::OutputInfo::isBScaleKeyword%3F8186480190.get
}

// Class OGIP_92aData 

//## begin module%399D65D4009E.epilog preserve=yes
//## end module%399D65D4009E.epilog


#endif
